pipeline {
  agent any
  
  
  environment {
    //Use Pipeline Utility Steps plugin to read information from pom.xml into env variables
    REVISION = "1.0.${env.BUILD_ID}"
    IMAGE = readMavenPom().getArtifactId()
    VERSION = readMavenPom().getVersion()
  }
  
  stages {

    
    stage('Maven Install') { 
      agent any
      steps {
        dir("frontend/agenda-view") {
           sh 'pwd'
           sh 'npm install'
           sh 'npm install --save-dev @angular-devkit/build-angular'
 		   sh 'ng build --prod --base-href /agenda/'
		}

        sh 'mvn clean package -Dmaven.test.skip=true'
        stash(name: 'app', includes: 'target/*.jar')
      }
    } 

    stage('Docker Build') {
      agent any
      steps {
        unstash 'app'
        sh 'docker build -t fatesgposmobile/agenda:${REVISION} .'
        sh 'docker build -t fatesgposmobile/agenda:latest .'
      }
    }
    stage('Docker Push') {
      agent any
      steps {
        withCredentials(bindings: [usernamePassword(credentialsId: 'dockerhub', passwordVariable: 'dockerHubPassword', usernameVariable: 'dockerHubUser')]) {
          sh "docker login -u ${env.dockerHubUser} -p ${env.dockerHubPassword}"
          sh 'docker push fatesgposmobile/agenda:${REVISION}'
          sh 'docker push fatesgposmobile/agenda:latest'
        }

      }
    }


  }
  
}
